package de.janchristiangruenhage.util;

import java.io.IOException;
import java.io.PrintStream;
import java.io.Writer;
import java.util.LinkedList;

/**
 * Created by green on 12/8/2015.
 */
public class MultiOutput {
    LinkedList<Writer> writers;
    LinkedList<PrintStream> printStreams;

    public MultiOutput() {
        writers = new LinkedList<>();
        printStreams = new LinkedList<>();
    }

    public boolean add(Writer writer) {
        return writers.add(writer);
    }

    public boolean add(PrintStream printStream) {
        return printStreams.add(printStream);
    }

    public void println(String out) {
        for (Writer writer : writers) {
            try {
                writer.write(out + "\n");
                writer.flush();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        for (PrintStream printStream : printStreams) {
            printStream.println(out);
        }
    }
}
